# -*- coding: utf-8 -*-
# WinExplore- Global Plugin for NVDA
# winExplore v.5.7.1 du 15.10.2024.
from keyboardHandler import KeyboardInputGesture
import NVDAObjects
# from UIAHandler import handler
import controlTypes
if not hasattr(controlTypes, "Role"):
	setattr(controlTypes, "Role", type('Enum', (), dict(
	[(x.split("ROLE_")[1], getattr(controlTypes, x)) for x in dir(controlTypes) if x.startswith("ROLE_")])))
	setattr(controlTypes, "State", type('Enum', (), dict(
	[(x.split("STATE_")[1], getattr(controlTypes, x)) for x in dir(controlTypes) if x.startswith("STATE_")])))
	setattr(controlTypes, "role", type("role", (), {"_roleLabels": controlTypes.roleLabels})) 
import wx, sys
import time
import winUser
import ctypes
from gui import guiHelper, mainFrame
import queueHandler
import ui
import addonHandler
from . import shared
from .shared import *
import os.path
import core
_addonDir = os.path.join(os.path.dirname(__file__), "..", "..")
_curAddon = addonHandler.Addon(_addonDir)
_addonSummary = _curAddon.manifest['summary']
addonHandler.initTranslation()

def isOpened(dialog):
	if dialog._instance is None:
		return False
	msg = u"Une boite de dialogue est déjà ouverte"
	queueHandler.queueFunction(queueHandler.eventQueue, ui.message, msg)
	return True
	
def estW11 () :
	return (True if (sys.getwindowsversion().major ==10 and sys.getwindowsversion().build >20000) else False)
	
def traiteNom ( nom):  #self,
	if u"sans titre" in nom.lower() : nom=nom.split("- ")[1]
	if u"nouvel onglet" in nom.lower() : nom=nom.split("- ")[1]
	if u"document " in nom.lower() : nom=nom.split("- ")[1]
	if "en cours" in nom : 
		nom=nom.split(" -")[0]
	if  "tre ouverte" in nom :nom=nom.split(" :")[0]
	return nom		

class CommandsListDialog(wx.Dialog): 
	_instance = None

	def __new__(cls, *args, **kwargs):
		if CommandsListDialog._instance is None:
			return wx.Dialog.__new__(cls)
		return CommandsListDialog._instance

	def __init__(self, parent):
		if CommandsListDialog._instance is not None:
			return
		CommandsListDialog._instance = self
		title = CommandsListDialog.title = u"Les principales commandes pour winExplore." 
		self.labelText = "Description et commande :"
		super(CommandsListDialog, self).__init__(parent, wx.ID_ANY, title)
		self.doGui()
		
	def doGui(self):
		mainSizer = wx.BoxSizer(wx.VERTICAL)
		sHelper = guiHelper.BoxSizerHelper(self, orientation=wx.VERTICAL)
		self.listCommands = sHelper.addLabeledControl(self.labelText,wx.ListBox,id=wx.ID_ANY,style=wx.LB_SINGLE,size=(600, 300)) 
		self.listCommands.SetItems([obj for obj in self.getCommandsList()])  #[0]
		self.listCommands.Select(0)
		# the buttons
		bHelper = guiHelper.ButtonHelper(wx.HORIZONTAL)
		closeButton = bHelper.addButton(self, id=wx.ID_CLOSE, label= "Annuler" ) 
		sHelper.addItem(bHelper, flag=wx.ALIGN_RIGHT)  #RIGHT CENTER  LEFT
		mainSizer.Add(
			sHelper.sizer, border=guiHelper.BORDER_FOR_DIALOGS,
			flag=wx.ALL)
		mainSizer.Fit(self)
		self.SetSizer(mainSizer)
		# the events  
		closeButton.Bind(wx.EVT_BUTTON, lambda evt: self.Destroy())
		self.Bind(wx.EVT_ACTIVATE,self.onActivate)
		self.SetEscapeId(wx.ID_CLOSE)

	def Destroy(self):
		CommandsListDialog._instance = None
		super(CommandsListDialog, self).Destroy()
		
	def onActivate(self, evt):
		evt.Skip()

	"""def onKeydown(self, evt): # pour liste 
		keyCode=evt.KeyCode  # =evt.GetKeyCode()
		if  keyCode ==wx.WXK_SPACE :
			# wx.CallAfter(self.selectIcones10) 
			core.callLater(200,SendKey ,"Control+$")
		if  keyCode ==wx.WXK_RIGHT :
			if  self.listCommands.HasFocus(): 
				core.callLater(200,SendKey ,"alt+$")
				return		
		if keyCode ==wx.WXK_LEFT:   
			core.callLater(200,SendKey ,"nvda+$")
			return 				
		evt.Skip()
		# self.Close() """	

	def getCommandsList(self): 
		namesList=[
		('1. Pour le module feneExplore. '), 
		('Ouvrir le dialogue "Liste des éléments de la fenêtre" : NVDA+$'), 
		(' '), 
		('2. Pour le module rubExplore. '), 
		('Ouvrir le dialogue "Éléments dans l\'onglet du ruban" : Alt+$'),
		('Vocalisation de la liste des onglets d\'un ruban : Alt+Maj+$'),
		(' '), 
		('3. Pour le module Barre des tâches. '), 
		('Ouvrir le dialogue "Liste des applications actives dans la barre des tâches" : Control+$'),
		('Ouvrir le dialogue "Liste de toutes les applications dans la barre des tâches" : Control+Maj+$'),
		('Activer la fenêtre au premier plan à partir de la barre des tâches : NVDA+Control+Maj+$'),
		('Avec Windows 11, réorganisation des icônes : Control+Maj+ flèches gauche, droite, haut'), 
		(' '), 
		('4. Autres commandes. '), 
		('Ouvrir le dialogue "Principales commandes pour winExplore" : NVDA+Maj+$'),
		('Recherche manuelle d\'une mise à jour de l\'extension : Alt+Control+Maj+$ simple et double frappe'),
		('Navigation par objets : permuter entre les commandes "séquentielles" et "groupées" : NVDA+Control+$'),
		('Atteindre l\'objet suivant/précédent en mode "groupées" : NVDA+Control+Page suivante/précédente'), 
		('Atteindre le premier objet de la fenêtre et en faire l\'objet navigateur  : NVDA+Control+Maj+Origine')
		]
		return namesList	
		
	@classmethod
	def run(cls):  
		if isOpened(cls):
			return
		mainFrame.prePopup()
		d = cls(mainFrame)
		d.CentreOnScreen()
		d.Show()
		mainFrame.postPopup()
	
	
class ElementsListDialog(wx.Dialog): 
	_instance = None
	clip=-1

	def __new__(cls, *args, **kwargs):
		if ElementsListDialog._instance is None:
			return wx.Dialog.__new__(cls)
		return ElementsListDialog._instance

	def __init__(self, parent):
		global twice
		if ElementsListDialog._instance is not None:
			return
		ElementsListDialog._instance = self
		title = ElementsListDialog.title = u"Liste des applications dans la barre des tâches." 
		self.labelText = ""
		if sys.getwindowsversion().major < 10 :self.labelText = u"Les applications : "
		else : self.labelText = (u"Toutes les applications :" if twice==True else "Applications actives :") 
		super(ElementsListDialog, self).__init__(parent, wx.ID_ANY, title)
		self.doGui()
		
	def updateList(self):
		self.iconsList.AppendItems(self.getIconsList()) 
		if self.iconsList.Count: self.iconsList.Select(0)
		
	def doGui(self):
		global twice
		mainSizer = wx.BoxSizer(wx.VERTICAL)
		sHelper = guiHelper.BoxSizerHelper(self, orientation=wx.VERTICAL)
		self.iconsList = sHelper.addLabeledControl(self.labelText,wx.ListBox,id=wx.ID_ANY,style=wx.LB_SINGLE,size=(500, 250)) 
		self.updateList()
		# the buttons
		bHelper = guiHelper.ButtonHelper(wx.HORIZONTAL)
		rightClickButton = bHelper.addButton(self, label=u"Simple clic &droit")
		leftClickButton = bHelper.addButton(self, label="Simple clic &gauche")
		leftClickButton.SetDefault()	
		dragdropButton= bHelper.addButton(self, label=u"&Espace pour le déplacement d'icône")
		closeButton = bHelper.addButton(self, id=wx.ID_CLOSE, label= "Annuler" ) 
		sHelper.addItem(bHelper, flag=wx.ALIGN_CENTER)  #RIGHT
		mainSizer.Add(
			sHelper.sizer, border=guiHelper.BORDER_FOR_DIALOGS,
			flag=wx.ALL)
		mainSizer.Fit(self)
		self.SetSizer(mainSizer)
		# the events  
		self.iconsList.Bind(wx.EVT_KEY_DOWN, self.onKeydown)
		rightClickButton.Bind(wx.EVT_BUTTON, self.onRightMouseButton)
		leftClickButton.Bind(wx.EVT_BUTTON, self.onLeftClick)
		dragdropButton.Bind(wx.EVT_BUTTON, self.onDadClick)
		closeButton.Bind(wx.EVT_BUTTON, lambda evt: self.Destroy())
		self.SetEscapeId(wx.ID_CLOSE)
		self.iconsList.SetFocus()

	def Destroy(self):
		ElementsListDialog._instance = None
		super(ElementsListDialog, self).Destroy()

	def getIconsList(self): 
		global twice, oListe
		hd = ctypes.windll.user32.FindWindowExA(None, None, b"Shell_TrayWnd", None)
		if not hd :
			print ("pas de hd init")
			return
		if not estW11() :
			path = ( b"RebarWindow32", b"MSTaskSwWClass", b"MSTaskListWClass") 
			for element in path: hd = ctypes.windll.user32.FindWindowExA(hd, 0, element, 0)
		else : 
			path = (b"Windows.UI.Composition.DesktopWindowContentBridge", b"Windows.UI.Input.InputSite.WindowClass",b"TaskbarFrameRepeater")
			for element in path:
				hd=ctypes.windll.user32.FindWindowExA(None, None, b"Shell_TrayWnd", None)
				hd = ctypes.windll.user32.FindWindowExA(hd, 0, element, 0)
				if hd : break
		if not hd :
			print (u"hd non trouvé")
			return False
		oListe= NVDAObjects.IAccessible.getNVDAObjectFromEvent(hd,-4,0)
		if estW11() : oListe=oListe.firstChild.firstChild  
		max = oListe.childCount  
		self.PositionXY = []
		name, namesList= "",[]
		i0 =0 #1 if estW11() else 0)
		max0 =(max+1 if estW11() else max)
		for i in range(i0, max):    #  1 max + 1
			if (controlTypes.State.INVISIBLE in  oListe.children[i].states ): continue
			name = oListe.children[i].name 
			if name=="" : continue
			if twice==False and not "en cours" in name: continue  
			if u"sans titre" in name.lower() : name=name.split("- ")[1]
			if u"nouvel onglet" in name.lower() : name=name.split("- ")[1]
			if u"document " in name.lower() : name=name.split("- ")[1]
			if u"\\user" in name.lower() : name=name.split("- ")[1]
			if u"en cours" in name : 
				name=name.split("s d")[0]
				name=name.replace(u"en cour","ouvertes")
			if u"1 fenêtre ouvertes" in name :name=name.replace(u"- 1 fenêtre ouvertes","")
			name=name.replace(" -"," :")
			(x,y,w,h) = oListe.children[i].location 
			x1=int(x +  22)  	# x1 = int(x + w / 2)
			y1 = int(y+ h / 2)
			self.PositionXY.append((x1, y1))
			namesList.append(name)
		return namesList

	def getPositionXY(self):
		itemSelected = self.iconsList.GetSelection()
		xyItem = self.PositionXY[itemSelected]
		return xyItem

	def onLeftClick(self, event):
		self.clickLeftMouseButton(1)

	def onRightMouseButton(self, event):
		(x, y) = self.getPositionXY()
		self.Close()
		winUser.setCursorPos(x, y)
		winUser.mouse_event(winUser.MOUSEEVENTF_RIGHTDOWN, 0, 0, None, None)
		time.sleep(0.01)
		winUser.mouse_event(winUser.MOUSEEVENTF_RIGHTUP, 0, 0, None, None)
		wx.CallLater (50,KeyboardInputGesture.fromName ("upArrow").send )
		wx.CallLater (150,KeyboardInputGesture.fromName("upArrow").send )

	def onDadClick(self, evt):
		core.callLater(50,self.selectIcones10)  	
		core.callLater(100,self.iconsList.SetFocus)
		return
		evt.Skip()  

	def onKeydown(self, evt): # pour liste 
		keyCode=evt.KeyCode  # =evt.GetKeyCode()
		if  keyCode ==wx.WXK_SPACE :
			wx.CallAfter(self.selectIcones10) 
		if  keyCode ==wx.WXK_RIGHT :
			if  self.iconsList.HasFocus(): 
				core.callLater(200,SendKey ,"Tab")
				return		
		if keyCode ==wx.WXK_LEFT:   
			core.callLater(200,SendKey ,"Shift+Tab")
			return 				
		evt.Skip()	

	def clickLeftMouseButton(self, nb):
		self.Close()
		(x, y) = self.getPositionXY()
		winUser.setCursorPos(x, y)
		o=api.getDesktopObject().objectFromPoint(x, y)
		print (o.name)
		print (o.role)
		for i in range(nb):
			winUser.mouse_event(winUser.MOUSEEVENTF_LEFTDOWN, 0, 0, None, None)
			winUser.mouse_event(winUser.MOUSEEVENTF_LEFTUP, 0, 0, None, None) 
	
	def selectIcone111(self, srcIndex):
		if not estW11() : 
			return
		try : 	
			o = clientObject.ElementFromHandle (api.getDesktopObject().windowHandle).FindFirst(4,clientObject.CreateAndCondition (clientObject.CreatePropertyCondition (30011,"StartButton"),clientObject.CreatePropertyCondition (30012,"ToggleButton" )))
			o=clientObject.RawViewWalker.GetNextSiblingElement(o)
			i=1
			while o and i<srcIndex :
				o=clientObject.RawViewWalker.GetNextSiblingElement(o)
				i+=1
			o.SetFocus() 
			wx.CallLater (100,commands.script_navigatorObject_current,None)
			wx.CallLater (300,commands.script_navigatorObject_moveFocus,None)
		except :
			beep(150,50)
			return		
	
	def selectIcone11(self,srcIndex,targIndex) :
		global oListe
		nom =oListe.children[srcIndex-1]
		max=oListe.childCount
		o=None
		try :
			oldSpeechMode = getSpeechMode()
			speech.cancelSpeech()
			setSpeechMode_off()
			self.selectIcone111(srcIndex)
			sleep(0.3)
			i=srcIndex
			if targIndex > srcIndex :
				while i<max and i<targIndex :
					KeyboardInputGesture.fromName("alt+shift+RightArrow").send()
					sleep(0.2)
					i+=1
			if targIndex < srcIndex :
				while i>1 and i>targIndex :
					KeyboardInputGesture.fromName("alt+shift+LeftArrow").send()
					sleep(0.2)
					i-=1  
			wx.CallLater(600,self.vocalSelectIcone11,0)
			sleep(0.2)
			api.processPendingEvents()
			sleep(0.2)
			setSpeechMode(oldSpeechMode)	
		except :
			return ui.message(u"L'icône n'a pas été focalisée.")	

	def vocalSelectIcone11 (self,nb):
		if nb==2 :KeyboardInputGesture.fromName("alt+shift+RightArrow").send()
		if nb==1  :KeyboardInputGesture.fromName("alt+shift+LeftArrow").send()
		sleep(0.1)
		nom=nom0=nom1=""
		o=None
		try: 
			o=api.getFocusObject() 		
			if "N" in api.getFocusObject().name :  
				wx.CallLater (100,commands.script_navigatorObject_current,None)
				wx.CallLater (200,commands.script_navigatorObject_moveFocus,None)
			# if not o :
				# return ui.message (u"Pas d'icône focalisée trouvée dans la barre des tâches.")
		except : return ui.message (u"Pas d'icône focalisée trouvée dans la barre des tâches.")
		nom =traiteNom (o.name)
		try : nom0=traiteNom (o.previous.name) 
		except : nom0= ""		
		try : nom1=traiteNom (o.next.name)
		except : nom1= ""		
		msg =""
		if nom0=="" : msg = (nom +u" avant "+ nom1)
		elif nom1=="" : msg = (nom +u" après "+ nom0)
		else : msg =(nom +u" après "+ nom0+" et avant "+nom1)		
		api.processPendingEvents()
		sleep(0.1)
		wx.CallLater(50,ui.message,msg)
	
	def selectIcones10(self) :
		if self.clip ==  -1 : 
		# source
			self.clip = self.iconsList.GetSelections()[0]
			if estW11() :
				if self.clip==0 : 
					msg=u" car l'écran de démarrage ne peut pas être déplacé."
					self.clip =  1
					self.iconsList.Select(1)
					wx.CallLater(100,ui.message,msg)
			nom=self.getIconsList()[self.clip]
			msg=(u"%s sélectionné.") % nom
			wx.CallLater(50, ui.message,msg)
			return
		destC = self.iconsList.GetSelections()[0]
		if destC == self.clip :
			nom =self.getIconsList()[self.clip]
			msg=(u"L'icône %s ne peut pas être déplacée sur elle-même.") % nom
			wx.CallLater(50, ui.message,msg)  
			return
		msg =  self.moveIcone(self.clip, destC)
		if msg :
			self.iconsList.SetSelection(destC)
			wx.CallLater(300, ui.message, msg)  #20 
		else :
			beep(150, 100)		
	
	def moveIcone(self, srcIndex, targIndex) :  
		global oListe
		if estW11() : 
			wx.CallLater(300,self.selectIcone11,srcIndex, targIndex)
			self.Destroy()
			return 
		try:
			xSource =self.PositionXY[srcIndex][0]
			ySource =self.PositionXY[srcIndex][1]
			srcName = self.getIconsList()[srcIndex] 
			xTarget =self.PositionXY[targIndex][0]
			targName = self.getIconsList()[targIndex] 
			toRight = (True if xSource < xTarget else False )
		except TypeError:
			print ("TypeError")
			return None
		# print ("begin drag")
		i = 0 # setCursorPos counter
		wait = 0.0002  # interval between 2 setCurPos
		mod = 10 # modulo factor
		winUser.setCursorPos (xSource, ySource)
		if winUser.getKeyState(winUser.VK_LBUTTON)&32768:
			winUser.mouse_event(winUser.MOUSEEVENTF_LEFTUP,0,0,None,None)
		winUser.mouse_event(winUser.MOUSEEVENTF_LEFTDOWN,0,0,None,None)  #1
		sleep(0.001) 
		if toRight :
			while xSource<xTarget :
				xSource=(xTarget if xSource>xTarget or (xTarget- xSource)<10 else xSource+10)
				winUser.setCursorPos (xSource, ySource)
				i += 1
				if i % mod == 0 :
					beep(250, 1)
				sleep(wait)
		else : 
			while xSource>xTarget :
				xSource=(xTarget if xSource<xTarget or (xSource- xTarget)<10  else xSource-10)
				winUser.setCursorPos (xSource, ySource)
				i += 1
				if i % mod == 0 :
					beep(440, 1)
				sleep(wait)  
		winUser.setCursorPos (xTarget,ySource)
		winUser.mouse_event(winUser.MOUSEEVENTF_LEFTUP,0,0,None,None)
		srcName=""
		mess = ( u"{0} après {1}".format(srcName,targName) if toRight else u"{0} avant {1}".format(srcName,targName) )
		self.iconsList.Clear()
		sleep(0.4)
		self.iconsList.AppendItems(self.getIconsList())
		self.iconsList.Select(0) 
		self.iconsList.SetFocus()
		self.clip =  -1
		setForegroundWindow(self.GetHandle())
		return mess
			
	@classmethod
	def run(cls,applis):  
		if isOpened(cls):
			return
		global twice
		twice=applis
		mainFrame.prePopup()
		d = cls(mainFrame)
		d.CentreOnScreen()
		d.Show()
		mainFrame.postPopup()
			
