# coding :utf-8

# winExplore extension pour NVDA
# winExplore v.5.6 du 22.03.2023.
import controlTypes
if not hasattr(controlTypes, "Role"):
	setattr(controlTypes, "Role", type('Enum', (), dict(
	[(x.split("ROLE_")[1], getattr(controlTypes, x)) for x in dir(controlTypes) if x.startswith("ROLE_")])))
	setattr(controlTypes, "State", type('Enum', (), dict(
	[(x.split("STATE_")[1], getattr(controlTypes, x)) for x in dir(controlTypes) if x.startswith("STATE_")])))
	setattr(controlTypes, "role", type("role", (), {"_roleLabels": controlTypes.roleLabels}))
import api, ui
import re
import sys
import speech
from time import sleep
import winUser
from winUser import * 
from keyboardHandler import KeyboardInputGesture
from tones import beep
import UIAHandler
from UIAHandler import handler
from NVDAObjects.IAccessible import WindowRoot,getNVDAObjectFromPoint, getNVDAObjectFromEvent
import addonHandler
_curAddon = addonHandler.getCodeAddon()
_scriptCategory = _curAddon.manifest['summary']
clientObject = handler.clientObject
cO=clientObject
CPC=clientObject.CreatePropertyCondition

listeTypes=("Boutons",u"Onglets",u"Éléments d'arborescence","Liens",u"Zones d'édition",u"Listes et éléments de liste",u"Listes déroulantes et zones de listes modifiables",u"Éléments de menus",u"Cases à cocher et boutons-radio", "Tous") 
nomRolesMSAA = [
"","","","","","","","","Alerte",u"Fenêtre",
"Client","Menu contextuel",u"Élément de menu","Astuce","Application","Document","Volet","","","",
"Groupement",u"Séparateur",u"Barre d'outils",u"Barre d'état","Tableau","","","","","Cellule",
"Lien","","","Liste",u"Élément de liste","Arborescence",u"Élément d'arborescence","Onglet",u"Page de propriétés","",
"","Texte","Texte modifiable","Bouton",u"Case à cocher","Bouton-radio","Zone de liste modifiable","Liste déroulante","","Bouton rotatif",
"",u"Potentiomètre",u"Zone de sélection numérique","","","",u"Bouton de liste déroulante","Bouton de menu",u"Bouton de liste déroulante de grille","",
"Liste d'onglets","Horloge","Bouton partager","","","","","","",""]
oRub=None
oDeb = None

def isRibbonRoot(obj):
	if obj.name == "Ribbon" and obj.role == 3:  #roles.PANE
		return True
	return False

def testRuban(self) :
	"""print (api.getForegroundObject().name)
	oCondition1=CPC(30005,u"Onglets du ruban")
	oCondition2=cO.CreateOrCondition(CPC(30003,50018),CPC(30003,50033))
	oCondition =cO.CreateAndCondition(oCondition2,oCondition1)	
	# oCondition=cO.CreateAndCondition(CPC(30003,50018),CPC(30005,u"Onglets du ruban")) 
	if cO.ElementFromHandle(getRootAppli().windowHandle).FindFirst(4,oCondition) : """
	import globalVars
	obj=api.getForegroundObject()
	for obj in reversed(globalVars.focusAncestors):
		if isRibbonRoot(obj):
			return True
	# return False
	# if isRibbonRoot() :
		# return True
		# else : 
	return False	
		
def getlisteRubOnglets(self) : 
	try : 
		oRub=objRub()
		o1 =oRub.parent
		for i in range(0, o1.childCount):
			if "onglets du ruban" in o1.children[i].name.lower() :
				break
		o=o1.children[i]
		if o.firstChild.name=="" :
			o=o.firstChild
		n=len(o.children)
		ui.message(u"Onglets du ruban : Fichier, ")
		for i in list(range(n)):
			if  not controlTypes.State.INVISIBLE in o.children[i].states:  
				name =o.children[i].name		
				ui.message(name)
	except : 
		beep(100,44)  
		return

def getRootAppli():
	try :
		obj = api.getForegroundObject()
		parent = obj.parent
		while obj.parent.windowClassName != "#32769" : 
			obj = obj.parent
		if obj.firstChild.name==u"Système" :
			obj = obj.firstChild.next.next
	except :	# except AttributeError:
		print ("AttributeError getRootAppli")
		obj=api.getForegroundObject()
	return obj 
	
def objRub() : 
	topObjet=getRootAppli() 
	try :
		oCondition1=cO.CreateOrCondition(CPC(30003,50018),CPC(30003,50033))  # onglets , volet
		oCondition2=CPC(30005,u"Onglets du ruban")
		oCondition =cO.CreateAndCondition(oCondition1,oCondition2)		
		# nomAppli=topObjet.appModule.productName
		if not cO.ElementFromHandle(topObjet.windowHandle).FindFirst(4,oCondition) :
			# o=api.getFocusObject() #.parent		
			if api.getForegroundObject().role ==4 :
				nom= api.getForegroundObject().name
				ui.message (u"La boite de dialogue "+nom+" est au premier plan")
			else : 
				ui.message (u"Fenêtre inactive ou sans ruban.")
			return None	
	except : 
		ui.message (u"Cette fenêtre est inactive ou sans ruban.")
		return None
		
	if cO.ElementFromHandle(topObjet.windowHandle).FindFirst(4,oCondition) :
		elem =cO.ElementFromHandle(topObjet.windowHandle).FindFirst(4,oCondition)
		(x,y,l,h) =elem.GetCurrentPropertyValue(30001) 
		o=getNVDAObjectFromPoint(int(x+10),int(y+10)) 
		while o and o.name !="Onglets du ruban" :
			o=o.parent
		o=o.parent
		j=0
		for i in range(0, o.childCount):
			if "ruban inf" in o.children[i].name.lower()and  not controlTypes.State.INVISIBLE in o.children[i].states : 
				j=1000
				break
		if j==0 :	
			ui.message (u"Le ruban est réduit. Frappez Control+Eff1 pour le développer.")
			return None		
		o1=o.children[i]
		if u"ruban inférieur" in o1.name.lower() and not controlTypes.State.INVISIBLE in o1.states :
			return o1
		else :
			# print (u"Problème. L'objet atteint est :"+o1.name)
			return None	

def versionWLM(self):  
	try :
		if appModuleHandler.getAppNameFromProcessID(api.getFocusObject().processID,True) =="wlmail.exe" :
			version = globalVars.foregroundObject.appModule.productVersion.split(".")[0]
			return int(version)
		else : return 0
	except : return 0	

def nombreMessagesWLM (self):
	nb=1
	oCondition= CPC(30011,"Header")
	try :
		elem=cO.ElementFromHandle(api.getForegroundObject().windowHandle).FindFirst(4,oCondition)
	except :	return
	try : 
		(x,y,l,h)=elem.GetCurrentPropertyValue(30001) 
		o=getNVDAObjectFromPoint(int(x+10),int(y+10))
		o=o.parent .parent 
		while  o and o.role!=14: 
			o=o.parent
		if o.childCount> 100: nb = 1000
	except : return 1000
	return nb
	
def pourBarreExplorer(self) :
	oCondition=CPC(30003 ,50017)
	hd =api.getForegroundObject().windowHandle	
	elem=clientObject.ElementFromHandle(hd).FindFirst(4,oCondition)
	if elem :
		try :
			elems=elem.FindAll(4,cO.CreateTrueCondition())
			for e in range (0,elems.Length) :
				if elems.GetElement(e).GetCurrentPropertyValue(30095)==41 :
					name=elems.GetElement(e).CurrentName
					if "(" in name : name= name[:-3] 
					ui.message( name)
		except : return ui.message (u"Ligne d'état non trouvée")	

def pourBarreFirefox(self) :
	group = searchAmongTheChildren(("tag", "tabpanels"), api.getForegroundObject())
	beep(111,44)  
	if group:
		for propertyPage in filter(lambda o: o.role == controlTypes.Role.PROPERTYPAGE, group.children):  #APPLICATION  
			try:
				# obj = next(filter(lambda o: o.role == controlTypes.Role.STATUSBAR, propertyPage.children))
				obj = filter(lambda o: o.role == controlTypes.Role.STATUSBAR, propertyPage.children)[0]
				break
			except IndexError:
				pass
		try:
			ui.message(obj.name)
		except NameError:
			ui.message (u"Ligne d'état sans donnée")
		else:
			if scriptHandler.getLastScriptRepeatCount() == 1:
				if api.copyToClip(obj.name):
					ui.message(u"Copié dans le presse-papier.")
		return
	else : ui.message (u"Ligne d'état non trouvée")

	
"""def script_statusBar(self, gesture):	
	try :
		if appModuleHandler.getAppNameFromProcessID(api.getFocusObject().processID,True) =="explorer.exe" : 
			self.pourBarreExplorer()
		# elif appModuleHandler.getAppNameFromProcessID(api.getFocusObject().processID,True) in ["firefox.exe" ,"waterfox.exe"]: 
			# self.pourBarreFirefox()				
		else : 
			commands.script_reportStatusLine(gesture)
	except : 
		gesture.send()
		return
script_statusBar.__doc__ = (u"Lit la ligne d'état. Une double ou une triple frappe la copie dans le presse-papier.")
script_statusBar.category = _scriptCategory	"""

	
def SendKey(keys) :
	KeyboardInputGesture.fromName(keys).send()

def searchObject(path):
	obj = api.getForegroundObject()
	for milestone in path:
		obj = searchAmongTheChildren(milestone, obj)
		if not obj:
			return
	return obj

def searchAmongTheChildren(id, into):
	if not into:
		return(None)
	key, value = id
	obj = into.firstChild
	if hasattr(obj, "IA2Attributes") and key in obj.IA2Attributes.keys():
		if re.match(value, obj.IA2Attributes[key]):
			return(obj)
	while obj:
		if hasattr(obj, "IA2Attributes") and key in obj.IA2Attributes.keys():
			if re.match(value, obj.IA2Attributes[key]):
				break
		obj = obj.next
	return(obj)
	
# Python3 compatibility fixes
py3flag = True if sys.version[:1] == "3" else False

if py3flag:
	__filter_class__ = filter
	def filter(*args):
		return [item for item in __filter_class__(*args)]
		
def PutWindowOnForeground(hwnd, sleepNb, sleepTime):
	winUser.setForegroundWindow(hwnd)
	for i in [sleepTime]*(sleepNb-1):
		sleep(i)
		if winUser.getForegroundWindow() == hwnd:
			return True
	# last chance
	KeyboardInputGesture.fromName("alt+Tab").send()
	sleep(sleepTime)
	if winUser.getForegroundWindow() == hwnd:
		return True
	return False
	
# new speechMode functions by Paulber19 for NVDA 2021.1+ and previous 
def getSpeechMode():
	try:
		return speech.getState().speechMode
	except AttributeError:
		return speech.speechMode

def setSpeechMode(mode):
	try:
		speech.setSpeechMode(mode)
	except AttributeError:
		speech.speechMode = mode

def setSpeechMode_off():
	try:
		speech.setSpeechMode(speech.SpeechMode.off)
	except AttributeError:
		speech.speechMode = speech.speechMode_off